const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const post_engagements = sequelize.define(
    'post_engagements',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

engagement_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"view",


"like",


"comment",


"share",


"save"

        ],

      },

comment_text: {
        type: DataTypes.TEXT,
      
      

      },

engaged_at: {
        type: DataTypes.DATE,
      
      

      },

is_reward_eligible: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  post_engagements.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity












































//end loop



    db.post_engagements.belongsTo(db.posts, {
      as: 'post',
      foreignKey: {
        name: 'postId',
      },
      constraints: false,
    });

    db.post_engagements.belongsTo(db.users, {
      as: 'user',
      foreignKey: {
        name: 'userId',
      },
      constraints: false,
    });

    db.post_engagements.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.post_engagements.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.post_engagements.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return post_engagements;
};


